<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

@set_time_limit(0);

if(preg_match("/([^.]+)\.yml$/",$A_FILENAME,$match))
{ $sname=$match[1];
  $srow=A::$DB->getRow("SELECT * FROM ".DOMAIN."_sections WHERE name='".$sname."' AND (lang='".LANG."' OR lang='all')");
}

if(empty($srow)) return;

$section=DOMAIN."_".$srow['lang']."_".$srow['name'];
$idsec=$srow['id'];

header("Content-type: text/xml; charset=windows-1251");

require_once("modules/shoplite/include.php");
require_once 'XML/Serializer.php';

$options=getOptions(STRUCTURE);
$soptions=getOptions($section);

$xmloptions = array(
XML_SERIALIZER_OPTION_XML_DECL_ENABLED=>true,
XML_SERIALIZER_OPTION_XML_ENCODING=>"windows-1251",
XML_SERIALIZER_OPTION_DOCTYPE_ENABLED => true,
XML_SERIALIZER_OPTION_DOCTYPE =>'shops.dtd',
XML_SERIALIZER_OPTION_INDENT      => "\t",
XML_SERIALIZER_OPTION_LINEBREAKS  => "\n",
XML_SERIALIZER_OPTION_ROOT_NAME   => 'yml_catalog',
XML_SERIALIZER_OPTION_ROOT_ATTRIBS => array('date'=>date("Y-m-d H:i",time())),
XML_SERIALIZER_OPTION_DEFAULT_TAG => 'offer',
XML_SERIALIZER_OPTION_ATTRIBUTES_KEY =>'attr',
XML_SERIALIZER_OPTION_MODE => XML_SERIALIZER_MODE_SIMPLEXML
);

$serializer = new XML_Serializer($xmloptions);

$data = array('shop'=>array());
$data['shop']['name']=$options['name'];
$data['shop']['company']=$options['company'];
$data['shop']['url']="http://".DOMAINNAME;

$data['shop']['currencies']['currency']=array();
$data['shop']['currencies']['currency'][]['attr']=array('id'=>'RUR','rate'=>$options['rur']);
$data['shop']['currencies']['currency'][]['attr']=array('id'=>'USD','rate'=>$options['usd']);
$data['shop']['currencies']['currency'][]['attr']=array('id'=>'EUR','rate'=>$options['eur']);

$data['shop']['categories']['category']=array();

$idcats=getTextOption(STRUCTURE,'cats');
if($idcats=!empty($idcats)?unserialize($idcats):array())
$where="WHERE id IN(".implode(',',$idcats).")";
else
$where="";

A::$DB->query("SELECT * FROM {$section}_categories {$where} ORDER BY level,sort");
while($row=A::$DB->fetchRow())
{ $category=array();
  $category[]=$row['name'];
  $category['attr']=array();
  $category['attr']['id']=$row['id'];
  if(!empty($row['idker']) && (empty($cats) || in_array($row['idker'],$cats)))
  $category['attr']['parentId']=$row['idker'];
  $data['shop']['categories']['category'][]=$category;
}
A::$DB->free();

$data['shop']['offers']['offer']=array();

$where=!empty($idcats)?" AND idcat IN(".implode(',',$idcats).")":"";

A::$DB->query("SELECT * FROM {$section}_catalog WHERE active='Y'{$where} ORDER BY id");
while($row=A::$DB->fetchRow())
{ $offer=array();
  $offer['attr']=array();
  $offer['attr']['id']=$row['id'];
  $offer['attr']['available']=$row['iscount']>0?'true':'false';
  $offer['url']="http://".DOMAINNAME.encodelink(shoplite_createItemLink($row['id'],$section));
  $offer['price']=round($row['price'],2);
  $offer['currencyId']=$options['currencyId'];
  $offer['categoryId']=$row['idcat'];
  if($image=A::$DB->getRow("
  SELECT id,path FROM ".DOMAIN."_images
  WHERE idsec=$idsec AND iditem={$row['id']}
  ORDER BY sort LIMIT 0,1"))
  $offer['picture']="http://".DOMAINNAME."/".$image['path'];
  $offer['name']=$row['name'];
  $offer['description']=$soptions['autoanons']?"":strip_tags($row['description']);
  $data['shop']['offers']['offer'][]=$offer;
}
A::$DB->free();

$serializer->serialize($data);

die(mb_convert_encoding($serializer->getSerializedData(),"Windows-1251","UTF-8"));

function encodelink($link)
{
  if(preg_match("/[а-яА-Я]/iu",$link))
  { $link=explode('/',$link);
    foreach($link as $i=>$l)
    if(preg_match("/[а-яА-Я]/iu",$l))
    $link[$i]=urlencode($l);
    $link=implode('/',$link);
  }
  return $link;
}